package external

import (
	"bytes"
	"os/exec"
)

//go:generate counterfeiter -o fake_command_runner/fake_command_runner.go . CommandRunner
type CommandRunner interface {
	Run(cmd *exec.Cmd) ([]byte, []byte, error)
}

func NewCommandRunner() CommandRunner {
	return commandRunner{}
}

type commandRunner struct{}

func (c commandRunner) Run(cmd *exec.Cmd) ([]byte, []byte, error) {
	var stderr bytes.Buffer
	cmd.Stderr = &stderr

	stdout, err := cmd.Output()
	return stdout, stderr.Bytes(), err
}
